#define __OCICPP_INTERNAL_USE_
#include "Connection.h"



Cursor *Connection::execQuery(const char *query) {
	DEBUG(DLEV_INFO,"execQuery(%s) executed\n",query);
	Cursor *cur;
	try {
		cur=new Cursor(envhp,svchp,errhp);
		DEBUG(DLEV_DEBUG,"Prepare stmt\n");
		if(cur->prepare(query)==OCI_STMT_SELECT) {
			DEBUG(DLEV_DEBUG,"Execute Select Stmt\n");
			cur->exec();
			DEBUG(DLEV_DEBUG,"Describe\n");
			cur->describe();
			DEBUG(DLEV_DEBUG,"Define\n");
			cur->define();
			DEBUG(DLEV_DEBUG,"Query Executed ok\n");
		} else { // It was non-select request does not supported etall yet 
			DEBUG(DLEV_DEBUG,"Execute Non-select stmt\n");
			cur->exec(); 
		}
	} catch(OraError *err) {
		delete cur;
		throw; /* tell to application error occured */
	}
	return cur;	
}

void Connection::execUpdate(const char *request) {
	DEBUG(DLEV_INFO,"execQuery(%s) executed\n",request);
	Cursor *cur;
	try {
		cur=new Cursor(envhp,svchp,errhp);
		cur->prepare(request);
		cur->exec();
		delete cur;
	} catch (OraError *err) {
		delete cur;
		throw; /* Tell to application error occured */
	}
	
}

	