#ifndef __CURSOR_H_
#define __CURSOR_H_

#include "ocicpp.h"

#include "OraError.h"
#include "TableHead.h"
#include "RowCell.h"

	
class Cursor {
private:
	OCIEnv *envhp;
	OCISvcCtx *svchp;
	OCIStmt *stmthp;
	OCIParam *paramd;
	OCIError *errhp;
	OCIDefine **defineArr; /* Array of pointers to define descriptor */
	TableHead *head; /* Contains information about result set (colnames sizes types oracle and for inner use ).Array */
	RowCell *cell; /* Contains fetched row.Array */
	sb4 nCols;
	ub2 stmtType; /* Statement type as described in table 4-1 OCI Reference */
	sword status;
	char *nulltext; /* Text for null fields */
	int canFetch; /* Set's to 0 by constructor and to 1 by define() if define() finished successfully */
public:
	Cursor(OCIEnv *,OCISvcCtx *,OCIError *er);
	~Cursor();
	sb4 prepare(const char *);
	void exec();
	void describe();
	void define();
	int fetch();
	string *getStr(int col);
	int getStr(int col,string *);
	int getInt(int col);
	double getDouble(int col);
	sb4 getNCols();
	text *getColName(int col);
	int getColSize(int col);
	void setNullText(const char *nulltext);
private:			
	void correctTypes();
};
#endif